#ifndef MPEG2AUDIO_H
#define MPEG2AUDIO_H


#include "../bitstream.h"

#define MAXFRAMESIZE 1792
#define HDRCMPMASK 0xfffffd00
#define SBLIMIT 32
#define SSLIMIT 18
#define SCALE_BLOCK 12
#define MPEG2AUDIO_PADDING 1024

// Values for mode
#define MPG_MD_STEREO			0
#define MPG_MD_JOINT_STEREO 	1
#define MPG_MD_DUAL_CHANNEL 	2
#define MPG_MD_MONO 			3

struct al_table 
{
	short bits;
	short d;
};

typedef struct
{
	void* file;
	void* track;
	mpeg2_bits_t *astream;

	long outscale;
	long framenum;
	long prev_framesize;
	long framesize;           // Current framesize without header
	float avg_framesize;      // Includes the 4 byte header
	float *pcm_sample;        // Interlaced output from synthesizer
	int pcm_point;            // Float offset in pcm_sample to write to
	long pcm_position;        // Sample start of pcm_samples in file
	long pcm_size;            // Number of pcm samples in the buffer
	long pcm_allocated;       // Allocated number of samples in pcm_samples
	unsigned long oldhead;
	unsigned long newhead;
	unsigned long firsthead;
	int bsnum;
	int lsf;
	int mpeg25;
	int lay;                     // Layer 1, 2, or 3
	int sampling_frequency_code;
	int bitrate_index;
	int bitrate;
	int samples_per_frame;
	int padding;
	int extension;
	int mode;
	int mode_ext;
	int copyright;
	int original;
	int emphasis;
	int stereo;                  // 1 if mono, 2 if stereo
	int error_protection;
// Back step buffers for mp3
	unsigned char bsspace[2][MAXFRAMESIZE + 512]; /* MAXFRAMESIZE */
	unsigned char *bsbuf, *bsbufold;
	long ssize;
	int init;
	int single;
    struct al_table *alloc;
    int II_sblimit;
    int jsbound;
	int bo;                      // Static variable in synthesizer

// Static arrays here
	float synth_stereo_buffs[2][2][0x110];
	float synth_mono_buff[64];
	unsigned int layer2_scfsi_buf[64];

	float mp3_block[2][2][SBLIMIT * SSLIMIT];
	int mp3_blc[2];
} mpeg2audio_t;



#endif
