#ifndef MPEG2PROTOS_H
#define MPEG2PROTOS_H


// DEMUX

mpeg2_demuxer_t* mpeg2_new_demuxer(mpeg2_t *file, int do_audio, int do_video);
int mpeg2_delete_demuxer(mpeg2_t *file, mpeg2_demuxer_t *demuxer);
int mpeg2demux_read_data(mpeg2_t *file, mpeg2_demuxer_t *demuxer, unsigned char *output, long size);
unsigned int mpeg2demux_read_int32(mpeg2_t *file, mpeg2_demuxer_t *demuxer);
unsigned int mpeg2demux_read_int24(mpeg2_t *file, mpeg2_demuxer_t *demuxer);
unsigned int mpeg2demux_read_int16(mpeg2_t *file, mpeg2_demuxer_t *demuxer);
unsigned int mpeg2demux_read_char(mpeg2_t *file, mpeg2_demuxer_t *demuxer);
unsigned int mpeg2demux_read_prev_char(mpeg2_t *file, mpeg2_demuxer_t *demuxer);

// ATRACK

mpeg2_atrack_t* mpeg2_new_atrack(mpeg2_t *file);
int mpeg2_delete_atrack(mpeg2_t *file, mpeg2_atrack_t *atrack);

// VTRACK

mpeg2_vtrack_t* mpeg2_new_vtrack(mpeg2_t *file);
int mpeg2_delete_vtrack(mpeg2_t *file, mpeg2_vtrack_t *vtrack);

// AUDIO
mpeg2audio_t* mpeg2audio_new(mpeg2_t *file, mpeg2_atrack_t *track);
int mpeg2audio_delete(mpeg2audio_t *audio);


// VIDEO
mpeg2video_t* mpeg2video_new(mpeg2_t *file, mpeg2_vtrack_t *track);
int mpeg2video_delete(mpeg2video_t *video);
int mpeg2video_read_frame(mpeg2video_t *video, long frame_number, unsigned char *output);

// FILESYSTEM

mpeg2_fs_t* mpeg2_new_fs();
int mpeg2_delete_fs(mpeg2_fs_t *fs);
int mpeg2io_open_file(mpeg2_fs_t *fs, char *path);
int mpeg2io_close_file(mpeg2_fs_t *fs);
int mpeg2io_read_int32(mpeg2_fs_t *fs);
int mpeg2io_read_data(unsigned char *buffer, long bytes, mpeg2_fs_t *fs);

// BITSTREAM
mpeg2_bits_t* mpeg2bits_new_stream(mpeg2_t *file, mpeg2_demuxer_t *demuxer);
unsigned int mpeg2bits_getbits(mpeg2_bits_t* stream, int n);



#endif
