#ifndef FILETHREAD_H
#define FILETHREAD_H

#include "file.inc"
#include "mutex.h"
#include "thread.h"
#include "vframe.inc"

#define TOTAL_BUFFERS 2

class FileThread : public Thread
{
public:
	FileThread(File *file, int do_audio, int do_video);
	~FileThread();

// write data into next available buffer
	int write_buffer(long size, int use_alpha = 0, int use_float = 0, int compressed = 0);
	float** get_audio_buffer();     // get pointer to next buffer to be written and lock it
	VFrame*** get_video_buffer();     // get pointer to next buffer to be written and lock it

	void run();
	int start_writing(long buffer_size, int use_alpha = 0, int total_buffers = 2);
	int stop_writing();
	int swap_buffer();

	float **audio_buffer[TOTAL_BUFFERS];
	VFrame ***video_buffer[TOTAL_BUFFERS];  // *track, *array of frames, *frame
	long output_size[TOTAL_BUFFERS];   // Number of frames or samples to write
	int is_compressed[TOTAL_BUFFERS];   // Whether to use the compressed data in the frame
	Mutex output_lock[TOTAL_BUFFERS], input_lock[TOTAL_BUFFERS];
	int current_buffer;
	int local_buffer;
	int last_buffer[TOTAL_BUFFERS];
	int return_value;
	int do_audio;
	int do_video;
	int use_alpha, use_float;
	File *file;
	int buffer_size;
	int total_buffers;
};



#endif
