#ifndef PREVIEWTHREAD_H
#define PREVIEWTHREAD_H

#include "bcbase.h"
#include "file.inc"
#include "mutex.h"
#include "record.inc"
#include "recordgui.inc"
#include "recordengine.inc"
#include "thread.h"
//#include "videodevice.inc"




class PreviewVideo : public Thread
{
public:
	PreviewVideo(Record *record, RecordEngine *engine);
	~PreviewVideo();

	int set_parameters(/*VideoDevice *device, */RecordGUI *gui, File *file);
	int start_preview(long position);
	int stop_preview();



	int arm_buffer();
	int update_current_position();
	long get_current_position();

	void run();


	Mutex preview_complete;
	long preview_start, current_position, preview_end;
	int is_previewing;
//	VideoDevice *device;
	RecordEngine *engine;
	Record *record;
	File *file;
	RecordGUI *gui;
};

#endif
