#ifndef RECVIDEOWINDOW_H
#define RECVIDEOWINDOW_H

#include "bcbase.h"
#include "channelpicker.inc"
#include "record.inc"
#include "recordengine.inc"
#include "recordgui.inc"
#include "recordtransport.inc"
#include "recvideowindow.inc"

class RecordVideoWindow : public Thread
{
public:
	RecordVideoWindow(RecordEngine *engine, Record *record, RecordGUI *gui);
	~RecordVideoWindow();

	void run();

	int close_threads();   // Stop all the child threads on exit
	int create_objects();
	int update(VFrame *vframe);
	int fix_size(int &w, int &h, int width_given, float aspect_ratio);
	float get_scale(int w);
	int get_buttonbar_height();
	int get_canvas_height();
	int get_channel_x();
	int get_channel_y();

	RecordGUI *gui;
	Record *record;
	RecordEngine *engine;
	RecordVideoWindowGUI *window;
};

class RecordVideoWindowGUI : public BC_Window
{
public:
	RecordVideoWindowGUI(Record *record, 
		RecordVideoWindow *thread, 
		int w, int h);
	~RecordVideoWindowGUI();

	int create_objects();
	int resize_event(int w, int h);
	int set_title();
	int close_event();
	int create_bitmap();
	int button_press();
	int button_release();
	int cursor_motion();
	int get_virtual_center();
	int keypress_event();

	BC_SubWindow *buttonbar;
	BC_Canvas *canvas;
	BC_Bitmap *bitmap;
	RecordVideoWindow *thread;
	RecordGUITransport *record_transport;
	ChannelPicker *channel_picker;
	Record *record;
	int translating;
	int translate_zoom;
	int virtual_center_x, virtual_center_y;
};

#endif
