#include "mpeg2private.h"

#include <sys/stat.h>
#include <stdlib.h>

mpeg2_fs_t* mpeg2_new_fs()
{
	return malloc(sizeof(mpeg2_fs_t));
}

int mpeg2_delete_fs(mpeg2_fs_t *fs)
{
	free(fs);
	return 0;
}

int mpeg2io_open_file(mpeg2_fs_t *fs, char *path)
{
	strncpy(fs->path, path, MPEG2_STRLEN);
	if(!(fs->fd = fopen(fs->path, "rb")))
	{
		perror("mpeg2io_open_file");
		return 1;
	}
	return 0;
}

int mpeg2io_close_file(mpeg2_fs_t *fs)
{
	fclose(fs->fd);
	return 0;
}

int mpeg2io_read_data(unsigned char *buffer, long bytes, mpeg2_fs_t *fs)
{
	int result;
	result = !fread(buffer, 1, bytes, fs->fd);
	return result;
}

unsigned int mpeg2io_read_int32(mpeg2_fs_t *fs)
{
	int a, b, c, d;
	unsigned int result;
	a = (unsigned char)fgetc(fs->fd);
	b = (unsigned char)fgetc(fs->fd);
	c = (unsigned char)fgetc(fs->fd);
	d = (unsigned char)fgetc(fs->fd);
	result = ((int)a << 24) |
					((int)b << 16) |
					((int)c << 8) |
					((int)d);
	return result;
}

unsigned int mpeg2io_read_char(mpeg2_fs_t *fs)
{
	return fgetc(fs->fd);
}

long mpeg2io_total_bytes(mpeg2_fs_t *fs)
{
	 struct stat st;
	 if(stat(fs->path, &st) < 0) return 0;
	 return (long)st.st_size;
}

long mpeg2io_tell(mpeg2_fs_t *fs)
{
	return ftell(fs->fd);
}

int mpeg2io_seek(mpeg2_fs_t *fs, long byte)
{
	return fseek(fs->fd, byte, SEEK_SET);
}

int mpeg2io_seek_relative(mpeg2_fs_t *fs, long bytes)
{
	return fseek(fs->fd, bytes, SEEK_CUR);
}

int mpeg2io_eof(mpeg2_fs_t *fs)
{
	return feof(fs->fd);
}

