#ifndef MPEG2DEMUX_H
#define MPEG2DEMUX_H

#include "mpeg2io.h"
#include <stdio.h>

typedef struct
{
	void* file;
	mpeg2_fs_t fs;
// Data consisting of the multiplexer packet
	unsigned char *raw_data;
	long raw_offset;
	int raw_size;
	long packet_size;
// Only one is on depending on which track owns the demultiplexer.
	int do_audio;
	int do_video;
// Data consisting of the elementary stream
	unsigned char *data_buffer;
	long data_size;
	long data_position;
	long data_allocated;
// Remember when the file descriptor is at the beginning of the packet just read.
	int reverse;
// Set to 1 when eof or attempt to read before beginning
	int error_flag;
// Temp variables for returning
	unsigned char next_char;

	int transport_error_indicator;
	int payload_unit_start_indicator;
	int pid;
	int transport_scrambling_control;
	int adaptation_field_control;
	int continuity_counter;
	int is_padding;
	int pid_table[MPEG2_PIDMAX];
	int continuity_counters[MPEG2_PIDMAX];
	int total_pids;
	int adaptation_fields;
	double time;           // Time in seconds
	int audio_pid;
	int video_pid;
	int astream;     // Video stream ID.  -1 = select first ID in stream
	int vstream;     // Audio stream ID.  -1 = select first ID in stream
	long program_association_tables;
	int table_id;
	int section_length;
	int transport_stream_id;
	long pes_packets;
	double pes_audio_time;  // Presentation Time stamps
	double pes_video_time;  // Presentation Time stamps

// Program packet
	long pes_audio_bytes;
	long pes_video_bytes;
} mpeg2_demuxer_t;

#endif
