#ifndef MPEG2PRIVATE_H
#define MPEG2PRIVATE_H

#include "mpeg2private.inc"
#include "mpeg2atrack.h"
#include "mpeg2io.h"
#include "mpeg2vtrack.h"

typedef struct
{
	mpeg2_fs_t fs;  // Store the path here
	long packet_size;
	long total_bytes;     // Total bytes in file.  Critical for seeking and length.
// Only one of these is set to 1 to specify what kind of stream we have.
	int is_transport_stream;
	int is_program_stream;
	int is_audio_stream;         // Elemental stream
	int is_video_stream;         // Elemental stream
	int has_audio;
	int has_video;
	int cpus;
	mpeg2_atrack_t *atrack;
	mpeg2_vtrack_t *vtrack;
} mpeg2_t;




#endif
