#ifndef SLICE_H
#define SLICE_H

#include <pthread.h>

// Array of these feeds the slice decoders
typedef struct
{
	unsigned char *data;   // Buffer for holding the slice data
	int buffer_size;         // Size of buffer
	int buffer_allocation;   // Space allocated for buffer 
	int current_position;    // Position in buffer
	unsigned int bits;
	int bits_size;
	pthread_mutex_t completion_lock; // Lock slice until completion
	int done;           // Signal for slice decoder to skip
} mpeg2_slice_buffer_t;

// Each slice decoder
typedef struct
{
	void *video;     // mpeg2video_t
	mpeg2_slice_buffer_t *slice_buffer;

	int thread_number;      // Number of this thread
	int current_buffer;     // Buffer this slice decoder is on
	int buffer_step;        // Number of buffers to skip
	int last_buffer;        // Last buffer this decoder should process
	int fault;
	int done;
	int quant_scale;
	int pri_brk;                  // slice/macroblock
	short block[12][64];
	int sparse[12];
	pthread_t tid;   // ID of thread
	pthread_mutex_t input_lock, output_lock;
} mpeg2_slice_t;


#endif
