#include <stdio.h>
#include <stdlib.h>
#include <time.h>


static unsigned long long  mpeg2_MMX_U_80    = 0x0000008000800000;
static unsigned long long  mpeg2_MMX_V_80    = 0x0000000000800080;
static long long  mpeg2_MMX_U_COEF    = 0x00000058ffd30000;
static long long  mpeg2_MMX_V_COEF    = 0x00000000ffea006f;

// void inline mpeg2_bgra32_mmx(unsigned char *lum, unsigned char *cr, unsigned char *cb, unsigned char *row1)
// {
// 	asm("
// // Do firswt 4 
//             movd	   (%1),		      %%mm0;  // Load u  0  0  0  0  0  0 u1 u0
//             movd	   (%0),		      %%mm1;  // Load v  0  0  0  0 v3 v2 v1 v0
//             punpcklbw  %%mm7,		      %%mm0;  // Unpack u	0 u3  0 u2  0 u1  0 u0
// 			punpcklbw  %%mm7,		      %%mm1;  // Unpack v	0 v3  0 v2  0 v1  0 v0
//             psubw	   mpeg2_MMX_80w,     %%mm0;  // Subtract 0x80 from each pixel
//             psubw	   mpeg2_MMX_80w,     %%mm1;
// 
//             movq	   %%mm0,		      %%mm2;  // Make a copy of cb 0 u3  0 u2  0 u1  0 u0
//             movq	   %%mm1,		      %%mm3;  // Make a copy of cr
//             pmullw     mpeg2_MMX_UtoG,    %%mm2;  // Convert Cb to green 0 R3  0 R2  0 R1  0 R0
//             movq       (%2),              %%mm6;  // Load L1  L7 L6 L5 L4 L3 L2 L1 L0
//             pmullw     mpeg2_MMX_UtoB,    %%mm0;  // Convert Cb to blue
//             pand       mpeg2_MMX_00FFw,   %%mm6;  // Take only half of L  00 L6 00 L4 00 L2 00 L0
//             pmullw     mpeg2_MMX_VtoG,    %%mm3;  // Convert Cr to green
//             movq       (%2),              %%mm7;  // Load L2
//             pmullw     mpeg2_MMX_VtoR,    %%mm1;  // Convert Cr to red
//             psrlw	   $8,  			  %%mm7;  // Shift L2 to less significant 00 L7 00 L5 00 L3 00 L1
//             pmullw     mpeg2_MMX_Y,       %%mm6;  // Scale L1
//             paddw      %%mm3,             %%mm2;  // Cb2green + Cr2green == green
//             pmullw     mpeg2_MMX_Y,       %%mm7;  // Scale L2
// 
//             movq       %%mm6,             %%mm4;  // Make a copy of L1
//             paddw      %%mm0,             %%mm6;  // Add L1 + blue  00 B6 00 B4 00 B2 00 B0
//             movq       %%mm4,             %%mm5;  // Make another copy of lum1
//             paddw      %%mm1,             %%mm4;  // Add L1 + red   00 R6 00 R4 00 R2 00 R0
//             paddw      %%mm2,             %%mm5;  // Add L1 + green 00 G6 00 G4 00 G2 00 G0
//             psraw      $6,                %%mm4;  // Scale R1 down
//             movq       %%mm7,             %%mm3;  // Make a copy of L2  00 L7 00 L5 00 L3 00 L1
//             psraw      $6,                %%mm5;  // Scale G1 down
//             paddw      %%mm0,             %%mm7;  // Add L2 + blue 00 B7 00 B5 00 B3 00 B1
//             psraw      $6,                %%mm6;  // Scale B1 down
//             packuswb   %%mm4,             %%mm4;  // Pack R1 R1
//             packuswb   %%mm5,			  %%mm5;  // Pack G1 G1
//             packuswb   %%mm6,			  %%mm6;  // Pack B1 B1
// 	"
// 	:
// 	: "r" (cr), "r" (cb), "r" (lum), "r" (row1));
// }

inline void mpeg2_bgra32_mmx(unsigned long y, 
		unsigned long u, 
		unsigned long v, 
		unsigned long *output)
{
asm("
// Output will be 0x00rrggbb
	movd (%0), %%mm0;          // Load y   0x00000000000000yy
	movd (%1), %%mm1;          // Load u    0x00000000000000cr
	movq %%mm0, %%mm3;         // Copy y to temp
	psllq $16, %%mm1;          // Shift u   0x0000000000cr0000
	movd (%2), %%mm2;          // Load v    0x00000000000000cb
	psllq $16, %%mm3;          // Shift y
	movq %%mm1, %%mm4;         // Copy u to temp
	por %%mm3, %%mm0;          // Overlay new y byte 0x0000000000yy00yy
	psllq $16, %%mm4;          // Shift u
	movq %%mm2, %%mm5;         // Copy v to temp
	psllq $16, %%mm3;          // Shift y 
	por %%mm4, %%mm1;          // Overlay new u byte 0x000000cr00cr0000
	psllq $16, %%mm5;          // Shift v 
	por %%mm3, %%mm0;          // Overlay new y byte 0x000000yy00yy00yy
	por %%mm5, %%mm2;          // Overlay new v byte 0x0000000000cb00cb

// mm0: 0x000000yy00yy00yy mm1: 0x000000uu00uu0000 mm2: 0x0000000000vv00vv
 	psubw mpeg2_MMX_U_80, %%mm1;    // Subtract 128 from u 0x000000uu00uu0000
 	pmullw mpeg2_MMX_U_COEF, %%mm1; // Multiply u coeffs 0x0000uuuuuuuu0000
 	psllw $6, %%mm0;                // Shift y coeffs 0x0000yyy0yyy0yyy0
 	psubw mpeg2_MMX_V_80, %%mm2;    // Subtract 128 from v 0x0000000000cb00cb
 	pmullw mpeg2_MMX_V_COEF, %%mm2; // Multiply v coeffs 0x0000crcrcrcrcrcr

// mm0: 0x000000yy00yy00yy mm1: 0x0000uuuuuuuu0000 mm2: 0x00000000vvvvvvvv
	paddw %%mm1, %%mm0;        // Add u to result
	paddw %%mm2, %%mm0;        // Add v to result 0x0000rrrrggggbbbb
	psraw $6, %%mm0;           // Demote precision
	packuswb %%mm0, %%mm0;     // Pack into ARGB 0x0000000000rrggbb
	movd %%mm0, (%3);          // Store output
	"
:
: "r" (&y), "r" (&u), "r" (&v), "r" (output));
}


int main(int argc, char *argv[])
{
	unsigned char y[] = { 1, 2, 3, 4, 5 };
	unsigned char u[] = { 6, 7, 8, 9, 10 };
	unsigned char v[] = { 11, 12, 13, 14, 15 };
	unsigned char output[1024];

	*(unsigned long*)&output[4] = 0;
	*(unsigned long*)&output[0] = 0;
	mpeg2_bgra32_mmx(y[0], u[0], v[0], (unsigned long*)output);
	printf("%08x%08x\n", *(unsigned long*)&output[4], *(unsigned long*)&output[0]);
}
