#include "mainwindow.h"
#include "playbackengine.h"
#include "playbackscroll.h"







PlaybackScroll::PlaybackScroll(MainWindow *mwindow)
 : Thread()
{
	this->mwindow = mwindow;
}

PlaybackScroll::~PlaybackScroll()
{
}


int PlaybackScroll::start_playback()
{
	synchronous = 1;
	interrupt = 0;
	startup_lock.lock();
	start();
}

int PlaybackScroll::stop_playback()
{
	interrupt = 1;
}

int PlaybackScroll::wait_for_startup()
{
	startup_lock.lock();
	startup_lock.unlock();
}

int PlaybackScroll::wait_for_completion()
{
	join();
}

void PlaybackScroll::run()
{
	long position;
	Timer timer;

	startup_lock.unlock();
	while(!interrupt)
	{
		position = mwindow->engine->current_position();

		if(position != -1 && position > mwindow->current_sample)
		{
			mwindow->current_sample = position;
			
			mwindow->gui->lock_window();
			mwindow->gui->update_scrollbar();
			mwindow->gui->unlock_window();
		}
		timer.delay(250);
	}
}
