#ifndef SETTINGS_H
#define SETTINGS_H

#include "bcbase.h"
#include "mainwindow.inc"
#include "mutex.h"

class SettingsWindow;

class SettingsThread : public Thread
{
public:
	SettingsThread(MainWindow *mwindow);
	~SettingsThread();

	void run();
	int update_framerate();

	MainWindow *mwindow;
	float aspect_w, aspect_h;
	int square_pixels;
	int smp;
	long prebuffer_size;
	int thread_running;
	SettingsWindow *window;
	Mutex change_lock;
};


class SettingsWindow : public BC_Window
{
public:
	SettingsWindow(MainWindow *mwindow, SettingsThread *thread);
	~SettingsWindow();
	
	int initialize();
	
	MainWindow *mwindow;
	SettingsThread *thread;
	BC_Title *frame_rate;
};

class SettingsW : public BC_TextBox
{
public:
	SettingsW(SettingsThread *thread, int x, int y, char *string);
	~SettingsW();
	
	int handle_event();
	
	SettingsThread *thread;
};

class SettingsH : public BC_TextBox
{
public:
	SettingsH(SettingsThread *thread, int x, int y, char *string);
	~SettingsH();
	
	int handle_event();
	
	SettingsThread *thread;
};

class SettingsSquare : public BC_CheckBox
{
public:
	SettingsSquare(SettingsThread *thread, int x, int y);
	~SettingsSquare();
	
	int handle_event();
	
	SettingsThread *thread;
};

class SettingsSMP : public BC_CheckBox
{
public:
	SettingsSMP(SettingsThread *thread, int x, int y);
	~SettingsSMP();
	
	int handle_event();
	
	SettingsThread *thread;
};

class SettingsPrebuff : public BC_TextBox
{
public:
	SettingsPrebuff(SettingsThread *thread, int x, int y, char *string);
	~SettingsPrebuff();
	int handle_event();
	SettingsThread *thread;
};

class SettingsOK : public BC_BigButton
{
public:
	SettingsOK(int x, int y);
	~SettingsOK();
	int handle_event();
	int keypress_event();
};

class SettingsCancel : public BC_BigButton
{
public:
	SettingsCancel(int x, int y);
	~SettingsCancel();
	int handle_event();
	int keypress_event();
};

#endif
